diff --git a/include/map.h b/include/map.h
index 64389bb..8dc4bd9 100644
--- a/include/map.h
+++ b/include/map.h
@@ -24,49 +24,391 @@
 
 G_BEGIN_DECLS
 
+/** Normal GObject function to get the type (makes G_TYPE_MAP work,
+ * for instance).
+ */
+GType map_get_type(void) G_GNUC_CONST;
+
 #define G_TYPE_MAP			  map_get_type()
-#define G_IS_MAP(obj)		  G_TYPE_CHECK_INSTANCE_TYPE((obj), \
-                                  G_TYPE_MAP)
+
+/** Use to test whether you have a valid Map*.
+ */
+#define G_IS_MAP(obj)		  G_TYPE_CHECK_INSTANCE_TYPE((obj), G_TYPE_MAP)
 #define G_IS_MAP_CLASS(klass) G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_MAP)
 #define MAP_GET_CLASS(obj)	  G_TYPE_INSTANCE_GET_CLASS((obj), \
                                   G_TYPE_MAP, MapClass)
-#define MAP(obj)			  G_TYPE_CHECK_INSTANCE_CAST((obj), \
-                                  G_TYPE_MAP, Map)
+/** Use to cast to Map*.
+ */
+#define MAP(obj)		  G_TYPE_CHECK_INSTANCE_CAST((obj), G_TYPE_MAP, Map)
 #define MAP_CLASS(klass)	  G_TYPE_CHECK_CLASS_CAST((klass), \
                                   G_TYPE_MAP, MapClass)
 
-typedef struct
-{
-  gint num_rows;
-  gint num_cols;
-} MapSize;
-
+/** Main type for Maps in GNU Robots.
+ */
 typedef struct _Map Map;
 typedef struct _MapClass MapClass;
 
-struct _Map {
-  GObject 	object;
+typedef struct _MapLoc MapLoc;
+typedef struct _MapPrivate MapPrivate;
 
-  /* The actual Map */
-  gint 		**_map;
-  MapSize	size;
+struct _Map {
+  GObject 	object; /*!< the Map's parent instance */
 
-  gint 		errors;
+  MapPrivate    *priv; /*!< All values should be treated as private. */
 };
 
 struct _MapClass {
-  GObjectClass	parent_class;
+  GObjectClass	parent_class; /*!< the Map's parent class */
+};
+
+/** MapMove is used in the map-move signal to communicate information
+ *  about a move on the map.
+ */
+typedef struct _MapMove MapMove;
+
+/** MapMove is used in the map-move signal to communicate information
+ *  about a move on the map.
+ */
+struct _MapMove {
+  gchar thing;   /*!< The character reference describing the thing moved (usually it's the ROBOT). */
+  gint origin_x; /*!< Origin x-value for the move. */
+  gint origin_y; /*!< Origin y-value for the move. */
+  gint dest_x;   /*!< Destination x-value for the move. */
+  gint dest_y;   /*!< Destination y-value for the move. */
+};
+
+/** Struct to be used to pass around coordinates.
+ */
+typedef struct _MapCoords MapCoords;
+
+/** Struct to be used to pass around coordinates.
+ */
+struct _MapCoords {
+  gint x; /*!< x-coordinate */
+  gint y; /*!< y-coordinate */
 };
 
-/* some convenient macros */
-#define MAP_GET_OBJECT(map, x, y)	    	((map)->_map[(y)][(x)])
-#define MAP_SET_OBJECT(map, x, y, thing)	((map)->_map[(y)][(x)] = thing)
+/** \defgroup MConstructor Map Constructor
+ * @{
+ */
+
+/** Helper function to generate a new map.
+ *
+ * \param[in] max_x the maximum x value for the map.  max_x must be
+ *            positive.
+ * \param[in] max_y the maximum y value for the map.  max_y must be
+ *            positive.
+ *
+ * \returns A new *Map initialized to all walls.
+ */
+Map *    map_new_blank (gint max_x, gint max_y);
+
+/** @} */
+
+/** \defgroup MMassUpdate Map Mass Update Methods
+ * @{
+ */
+
+/** Initialize the map to all walls.
+ *
+ * Resets all the locations in self to be walls with no things in
+ * them.
+ *
+ * \param[in, out] self the map to update
+ *
+ * \returns TRUE if successful; FALSE otherwise.
+ */
+gboolean map_init_map(Map *self);
+/** Load a new map from a file.
+ *
+ * Loads a new map from the given filename.  Uses the map's dimensions
+ * from when the map was constructed.
+ *
+ * Initially all locations are set to be walls, so the load will add
+ * itself into a map the size of map_get_max_x and map_get_max_y.
+ *
+ * This will emit a map-update signal.
+ *
+ * \param[in, out] self the map to update
+ * \param[in] filename the path and name of the file to load.  It is
+ *            safe to free this after the function completes.
+ * \param[out] error a GError object representing details about errors
+ *             encountered. error is set to NULL if the function is
+ *             successful.
+ *
+ * \returns TRUE if successful; FALSE otherwise.
+ */
+gboolean map_load_filename(Map *self, const gchar *filename, GError **error);
+
+/** @} */
+
+/** \defgroup MModify Map Update Methods
+ * @{
+ */
+
+/** Set Location as walls or spaces.
+ *
+ * This will emit a map-update signal.
+ *
+ * \param[in, out] self the map to update.
+ * \param[in] x the x portion of the coordinate to update.
+ * \param[in] y the y portion of the coordinate to update.
+ * \param[in] is_wall supply TRUE to set the location to be a wall;
+ *            FALSE to set it to be a space.
+ *
+ * \returns TRUE if successful; FALSE otherwise.
+ */
+gboolean map_set_loc(Map *self, gint x, gint y, gboolean is_wall);
+
+/** Manipulating Things in Locations **/
+
+/** Remove the thing in the location (e.g. baddie, prize, food, ...).
+ *
+ * This will emit a map-update signal.
+ *
+ * \param[in, out] self the map to update.
+ * \param[in] x the x portion of the coordinate to update.
+ * \param[in] y the y portion of the coordinate to update.
+ *
+ * \returns TRUE if successful; FALSE otherwise.
+ */
+gboolean map_remove_thing(Map *self, gint x, gint y);
+/** Place the thing in the location (e.g. baddie, prize, food, ...).
+ *
+ * This will emit a map-update signal.
+ *
+ * \param[in, out] self the map to update.
+ * \param[in] x the x portion of the coordinate to update.
+ * \param[in] y the y portion of the coordinate to update.
+ * \param[in] thing_type thing's identifier as defined in configs.h
+ *            (e.g. ROBOT, BADDIE, PRIZE, FOOD).
+ * \param[in] orientation the direction the thing is facing (NORTH,
+ *            SOUTH, EAST, WEST as defined in configs.h).
+ * \param[in] thing usually supplied only for GRobots. Allows the
+ *            map_find_thing function to find the thing again even
+ *            after it has moved. For untracked things (baddies, food,
+ *            prizes), set this to NULL.
+ *
+ * \returns TRUE if successful; FALSE otherwise.
+ */
+gboolean map_place_thing(Map *self, gint x, gint y, gint thing_type,
+			 gint orientation, gpointer thing);
+/** Automatically place the thing on the map.
+ *
+ * Can be useful to automatically place objects like robots on maps
+ * that did not assign robot starting locations.
+ *
+ * This method will search the map from the top left to the bottom
+ * right looking for a location matching on_loc_thing_char on which to
+ * place thing_char.
+ *
+ * This will emit a map-update signal.
+ *
+ * \param[in, out] self the map to update.
+ * \param[in] thing_char thing's identifier as defined in configs.h
+ *            (e.g. ROBOT, BADDIE, PRIZE, FOOD).
+ * \param[in] orientation the direction the thing is facing (NORTH,
+ *            SOUTH, EAST, WEST as defined in configs.h).
+ * \param[in] thing usually supplied only for GRobots. Allows the
+ *            map_find_thing function to find the thing again even
+ *            after it has moved. For untracked things (baddies, food,
+ *            prizes), set this to NULL.
+ * \param[in] on_loc_thing_char the location/thing's identifier for
+ *            locations eligible to hold the thing_char being placed.
+ *            Most often this will be SPACE.  Defined in configs.h
+ *            (e.g. SPACE, ROBOT, BADDIE, PRIZE, FOOD, WALL).
+ *
+ * \returns TRUE if successful; FALSE otherwise.
+ */
+gboolean map_auto_place_thing_on(Map *self, gint thing_char,
+				 gint orientation, gpointer thing,
+				 gchar on_loc_thing_char);
+/** Automatically place the robot on the map.
+ *
+ * If the map assigned one or more starting locations for the robot,
+ * this will assign the robot to one of them from top to bottom,
+ * left to right (typewriter style).
+ *
+ * If no starting locations are available either because they have all
+ * been used or they were not assigned, calls map_auto_place_thing_on
+ * with on_loc_thing_char set to SPACE.
+ *
+ * If map_auto_place_thing_on fails, this will set location (1, 1) to be
+ * an empty space and will put the robot there.
+ *
+ * The robot will always be facing EAST.
+ *
+ * This will emit a map-update signal.
+ *
+ * \sa map_auto_place_thing_on
+ *
+ * \param[in, out] self the map to update.
+ * \param[in] robot the robot to place (should not be NULL).
+ *
+ * \returns TRUE if successful; FALSE otherwise.
+ */
+gboolean map_auto_place_robot(Map *self, gpointer robot);
+/** Rotate the thing in the location (e.g. robot, baddie, prize, food, ...).
+ *
+ * Normally only used for the robot, but is capable of tracking the
+ * orientation of any object on the map.
+ *
+ * This will emit a map-update signal.
+ *
+ * \param[in, out] self the map to update.
+ * \param[in] x the x portion of the coordinate to update.
+ * \param[in] y the y portion of the coordinate to update.
+ * \param[in] num_turns the number of quarter turns to take.  Positive
+ *            numbers turn clockwise; negative numbers turn
+ *            counter-clockwise.
+ *
+ * \returns TRUE if successful; FALSE otherwise.
+ */
+gboolean map_thing_turn_clockwise(Map *self, gint x, gint y, gint num_turns);
+/** Move the thing in the location (e.g. robot, baddie, prize, food, ...).
+ *
+ * Normally only used for the robot, but is capable of tracking the
+ * movement of any object on the map.
+ *
+ * map_move does not require that the two locations be adjacent.
+ *
+ * This will emit a map-move signal (there will be no map-update
+ * signal emitted).
+ *
+ * \param[in, out] self the map to update.
+ * \param[in] origin_x the x portion of the origin coordinate to update.
+ * \param[in] origin_y the y portion of the origin coordinate to update.
+ * \param[in] dest_x the x portion of the destination coordinate to update.
+ * \param[in] dest_y the y portion of the destination coordinate to update.
+ *
+ * \returns TRUE if successful; FALSE otherwise.
+ */
+gboolean map_move(Map *self, gint origin_x, gint origin_y,
+		  gint dest_x, gint dest_y);
+/** @} */
+
+/** \defgroup MGet Map Inquiry Methods
+ * @{
+ */
+
+/** Get the maximum allowed value of x for the given map (self).
+ *
+ * \param[in] self the map to inquire on.
+ *
+ * \returns the maximum x-value allowed on the map (the minimum value
+ *          is always 0).
+ */
+gint     map_get_max_x(Map *self);
+/** Get the maximum allowed value of y for the given map (self).
+ *
+ * \param[in] self the map to inquire on.
+ *
+ * \returns the maximum y-value allowed on the map (the minimum value
+ *          is always 0).
+ */
+gint     map_get_max_y(Map *self);
+
+/** Determine whether location (x, y) is a wall.
+ *
+ * \param[in] self the map to inquire on.
+ * \param[in] x the x portion of the coordinate to inquire.
+ * \param[in] y the y portion of the coordinate to inquire.
+ *
+ * \returns TRUE if the location is a wall; FALSE otherwise.
+ */
+gboolean map_get_loc(Map *self, gint x, gint y);
+
+/** Determine the orientation of the thing at location (x, y).
+ *
+ * \param[in] self the map to inquire on.
+ * \param[in] x the x portion of the coordinate to inquire.
+ * \param[in] y the y portion of the coordinate to inquire.
+ *
+ * \returns NORTH, SOUTH, EAST or WEST (as defined in configs.h).
+ *          Returns -1 on failure.
+ */
+gint     map_get_thing_orientation(Map *self, gint x, gint y);
+/** Determine the loc/thing char of the thing at location (x, y).
+ *
+ * \param[in] self the map to inquire on.
+ * \param[in] x the x portion of the coordinate to inquire.
+ * \param[in] y the y portion of the coordinate to inquire.
+ *
+ * \returns SPACE, WALL, ROBOT, BADDIE, PRIZE, FOOD (as defined in
+ *          configs.h).  Returns -1 on failure.
+ */
+gchar    map_get_loc_thing_char(Map *self, gint x, gint y);
+/** Determine whether thing is on the map and return its map
+ * information if it is.
+ *
+ * Searches the map (self) for the pointer thing.  Returns the value
+ * associated with the first thing it finds (it's possible to add the
+ * same thing multiple times, though this is not recommended).
+ *
+ * The parameters x, y and orientation are optional.  Supply NULL if
+ * you are not interested in any of those parameters.
+ *
+ * \param[in] self the map to inquire on.
+ * \param[in] thing the thing to inquire on---thing should not be NULL.
+ * \param[out] x the x portion of the coordinate found.  Set to NULL
+ *             if you do not need this information.
+ * \param[out] y the y portion of the coordinate found.  Set to NULL
+ *             if you do not need this information.
+ * \param[out] orientation the orientation of the thing found (NORTH,
+ *             SOUTH, EAST, WEST as defined in configs.h).  Set to
+ *             NULL if you do not need this information.
+ *
+ * \returns TRUE if the thing is found; FALSE otherwise.
+ */
+gboolean map_find_thing(Map *self, gpointer thing,
+			gint* x, gint* y, gint* orientation);
+/** Return the filename that was used to load the map.
+ *
+ * \param[in] self the map to inquire on.
+ *
+ * \returns the file name loaded or NULL.  If a filename is returned,
+ *          the caller is responsible for calling g_free on it when it
+ *          does not need it any longer.
+ */
+gchar*   map_get_filename(Map *self);
+
+/** @} */
 
-/* normal GObject stuff */
-GType map_get_type(void);
+/** \defgroup MUtil Map Coordinate Utility Methods
+ * @{
+ *
+ * Helper functions for dealing with direction logic.
+ */
+
+/** Given an orientation and a number of turns, calculate the new
+ * orientation if those turns were performed.
+ *
+ * \param[in] orientation the orientation (NORTH, SOUTH, EAST, WEST as
+ *            defined in configs.h).
+ * \param[in] num_turns the number of quarter turns to take.  Positive
+ *            numbers turn clockwise; negative numbers turn
+ *            counter-clockwise.
+ *
+ * \returns orientation the orientation (NORTH, SOUTH, EAST, WEST as
+ *          defined in configs.h).
+ */
+gint map_compute_clockwise_turn(gint orientation, gint num_turns);
+/** Calculate the coordinates of the location one away in the
+ * direction given by orientation.
+ *
+ * \param[in] from_x the x portion of the origin coordinates.
+ * \param[in] from_y the y portion of the origin coordinates.
+ * \param[in] orientation the orientation (NORTH, SOUTH, EAST, WEST as
+ *            defined in configs.h).
+ * \param[out] facing_x the x portion of the facing coordinates.
+ * \param[out] facing_y the y portion of the facing coordinates.
+ *
+ * \returns TRUE if successful; FALSE otherwise.
+ */
+gboolean map_compute_facing_coords(gint from_x, gint from_y, gint orientation,
+				   gint* facing_x, gint* facing_y);
 
-/* Our object functions */
-Map* map_new_from_file(const gchar *map, gint num_rows, gint num_cols);
+/** @} */
 
 G_END_DECLS
 
diff --git a/include/ui-arena.h b/include/ui-arena.h
index efcb32c..25c9dd5 100644
--- a/include/ui-arena.h
+++ b/include/ui-arena.h
@@ -44,41 +44,27 @@ typedef struct _UIArenaPrivate UIArenaPrivate;
 
 struct _UIArena
 {
-  GtkDrawingArea widget;
+  GtkVBox widget;
   UIArenaPrivate* priv;
 };
 
 struct _UIArenaClass
 {
-  GtkDrawingAreaClass parent_class;
+  GtkVBoxClass parent_class;
 };
 
 GType ui_arena_get_type(void) G_GNUC_CONST;
 
-GtkWidget *ui_arena_new();
-
-void ui_arena_set_map(UIArena *arena, Map *map);
-void ui_arena_postinit(UIArena *arena);
-void ui_arena_draw(UIArena *arena);
-void ui_arena_update_status(UIArena *arena, const gchar *fmt, const gchar *thing,
-	glong energy, glong score, glong shields);
-
-void ui_arena_add_thing(UIArena *arena, gint x, gint y, gint thing);
-void ui_arena_move_robot(UIArena *arena, gint from_x, gint from_y,
-	gint to_x, gint to_y, gint cdir, glong energy, glong score,
-	glong shields);
-void ui_arena_robot_smell(UIArena *arena, gint x, gint y, gint cdir,
-	glong energy, glong score, glong shields, const gchar *thing);
-void ui_arena_robot_zap(UIArena *arena, gint x, gint y, gint cdir,
-	gint x_to, gint y_to, glong energy, glong score, glong shields);
-void ui_arena_robot_feel(UIArena *arena, gint x, gint y, gint cdir,
-	gint x_to, gint y_to, glong energy, glong score, glong shields,
-	const gchar *thing);
-void ui_arena_robot_grab(UIArena *arena, gint x, gint y, gint cdir,
-	gint x_to, gint y_to, glong energy, glong score, glong shields);
-void ui_arena_robot_look(UIArena *arena, gint x, gint y, gint cdir,
-	gint x_to, gint y_to, glong energy, glong score, glong shields,
-	const gchar *thing);
+/* Constructor */
+
+GtkWidget *ui_arena_new(Map *map);
+
+/* Methods */
+
+void    ui_arena_draw      (UIArena *arena);
+
+void    ui_arena_set_map   (UIArena *arena, Map *map);
+Map    *ui_arena_get_map   (UIArena *self);
 
 G_END_DECLS
 
diff --git a/include/ui-status.h b/include/ui-status.h
new file mode 100644
index 0000000..ea0f336
--- /dev/null
+++ b/include/ui-status.h
@@ -0,0 +1,90 @@
+/* Copyright (C) 2008 Bradley Smith <brad@brad-smith.co.uk>
+ *
+ * GNU Robots, ui-arena.h
+ *
+ * GNU Robots is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * GNU Robots is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with GNU Robots.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __UI_STATUS_H__
+#define __UI_STATUS_H__
+
+#include <gtk/gtk.h>
+
+#include "grobot.h"
+
+G_BEGIN_DECLS
+
+/** Standard GObject class.  Necessary to make UI_TYPE_STATUS work,
+ *  for instance.
+ */
+GType ui_status_get_type(void) G_GNUC_CONST;
+
+#define UI_TYPE_STATUS ui_status_get_type()
+/** Use this to cast to UIStatus.
+ */
+#define UI_STATUS(obj)						\
+    G_TYPE_CHECK_INSTANCE_CAST(obj, UI_TYPE_STATUS, UIStatus)
+/** Use this to test whether this is a valid UIStatus object.
+ */
+#define IS_UI_STATUS(obj) \
+    G_TYPE_CHECK_INSTANCE_TYPE(obj, UI_TYPE_STATUS)
+
+/** Main typedef for the UIStatus object.
+ */
+typedef struct _UIStatus UIStatus;
+/** Main typedef for the UIStatus class object.
+ */
+typedef struct _UIStatusClass UIStatusClass;
+/** Main typedef for the UIStatus private data.
+ */
+typedef struct _UIStatusPrivate UIStatusPrivate;
+
+/** Main struct for the UIStatus object.
+ */
+struct _UIStatus
+{
+  GtkGrid widget;       /*!< the UIStatus's parent instance. */
+  UIStatusPrivate* priv; /*!< Private data for UIStatus. */
+};
+
+/** Class struct for UIStatus.
+ */
+struct _UIStatusClass
+{
+  GtkGridClass parent_class; /*!< Pointer to the parent class instance. */
+};
+
+/** Constructor to create a new UIStatus object.
+ *
+ * \returns the UIStatus cast as a GtkWidget.
+ */
+GtkWidget *ui_status_new      ();
+
+/** Function to set the robot for UIStatus.
+ *
+ * \param[in, out] self the object to set the robot on.
+ * \param[in]      robot the robot to set on UIStatus.
+ */
+void       ui_status_set_robot  (UIStatus *self, GRobot *robot);
+/** Function to get the robot for UIStatus.
+ *
+ * \param[in] self the object to inquire on.
+ *
+ * \returns the GRobot that is associated with this UIStatus object.
+ */
+GRobot*    ui_status_get_robot  (UIStatus *self);
+
+G_END_DECLS
+
+#endif
diff --git a/include/ui-window.h b/include/ui-window.h
index c8fa337..f2e32e1 100644
--- a/include/ui-window.h
+++ b/include/ui-window.h
@@ -19,42 +19,52 @@
 #ifndef __UI_WINDOW_H__
 #define __UI_WINDOW_H__
 
-#include "map.h"
-
-#include <gtk/gtkwindow.h>
+#include <gtk/gtk.h>
+#include <glib.h>
+#include "grobot.h"
 
 G_BEGIN_DECLS
 
-#define UI_TYPE_WINDOW \
-    ui_window_get_type()
-#define UI_WINDOW(obj) \
-    G_TYPE_CHECK_INSTANCE_CAST(obj, UI_TYPE_WINDOW, UIWindow)
-#define UI_WINDOW_CLASS(klass) \
-    G_TYPE_CHECK_CLASS_CAST(klass, UI_WINDOW_TYPE, UIWindowClass)
-#define IS_UI_WINDOW(obj) \
-    G_TYPE_CHECK_INSTANCE_TYPE(obj, UI_TYPE_WINDOW)
-#define IS_UI_WINDOW_CLASS(klass) \
-    G_TYPE_CHECK_CLASS_TYPE(klass, UI_TYPE_WINDOW)
-
-typedef struct _UIWindow UIWindow;
-typedef struct _UIWindowClass UIWindowClass;
+#define UI_WINDOW_TYPE              (ui_window_get_type())
+#define UI_WINDOW(obj)              (G_TYPE_CHECK_INSTANCE_CAST((obj), UI_WINDOW_TYPE, UIWindow))
+#define UI_WINDOW_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST((klass), UI_WINDOW_TYPE, UIWindowClass))
+#define UI_WINDOW_IS_UI_WINDOW(obj)           (G_TYPE_CHECK_INSTANCE_TYPE((obj), UI_WINDOW_TYPE))
+#define UI_WINDOW_IS_UI_WINDOW_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), UI_WINDOW_TYPE))
+#define UI_WINDOW_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS((obj), UI_WINDOW_TYPE, UIWindowClass))
+
+typedef struct _UIWindow        UIWindow;
+typedef struct _UIWindowClass   UIWindowClass;
 typedef struct _UIWindowPrivate UIWindowPrivate;
 
 struct _UIWindow
 {
-  GtkWindow widget;
-  UIWindowPrivate* priv;
+  GtkApplicationWindow window;
+
+  /*< private > */
+  UIWindowPrivate *priv;
 };
 
 struct _UIWindowClass
 {
-  GtkWindowClass parent_class;
+  GtkApplicationWindowClass parent_class;
 };
 
-GType ui_window_get_type(void) G_GNUC_CONST;
-
-GtkWidget *ui_window_new();
-void ui_window_postinit(UIWindow *window, Map* volatile* map);
+/** Initialize and kick-off the GUI process.  Does not return until
+ *  GTK exits.
+ *
+ * \param[in, out] map The map to display in ui-arena.
+ * \param[in, out] robot the robot to track in ui-stats.
+ *
+ * \returns the status from running the GtkApplication
+ */
+gint          ui_window_main(Map *map, GRobot *robot, gint argc, gchar **argv);
+/** Returns the GOptionGroup to be used in commandline processing.
+ *
+ * The GOptionGroup is found by calling gtk_get_option_group.
+ *
+ * Using this should render calling gtk_init unnecessary.
+ */
+GOptionGroup* ui_window_gtk_option_group();
 
 G_END_DECLS
 
diff --git a/scheme/Makefile.am b/scheme/Makefile.am
index df70bc8..62e28a4 100644
--- a/scheme/Makefile.am
+++ b/scheme/Makefile.am
@@ -19,6 +19,7 @@ schemedir = $(pkgdatadir)/scheme
 
 scheme_DATA =\
  beep.scm\
+ bot-wander.scm\
  greedy.scm\
  mapper.scm\
  simple.scm\
@@ -27,6 +28,7 @@ scheme_DATA =\
 
 EXTRA_DIST =\
  beep.scm\
+ bot-wander.scm\
  greedy.scm\
  mapper.scm\
  simple.scm\
